# Class ModuleApplication<M, O, Env>

#### Type Parameters

- M
- O extends ModuleApplicationConfig
- Env extends Environment

#### Hierarchy (View Summary)

- Application<O, NgModuleRef<M>, Env>
  - ModuleApplication

- Defined in module-application.ts:18

#####
Index

### Constructors

constructor

### Properties

app
config
configLoadOptions?
environment
logger
options

### Methods

after
before
bootstrap
create
handleAfter
handleBefore
loadConfig
prepareConfig
prepareEnvironment

##
Constructors

### constructor

- new ModuleApplication<
  M,
  O extends ModuleApplicationConfig,
  Env extends Environment,
  >(
  environment: Env,
  moduleType: Type$1<M>,
  options?: O,
  configLoadOptions?: ConfigLoadOptions,
  ): ModuleApplication<M, O, Env>

  #### Type Parameters

  - M
  - O extends ModuleApplicationConfig
  - Env extends Environment

  #### Parameters

  - environment: Env
  - moduleType: Type$1<M>
  - `Optional` options: O
  - `Optional` configLoadOptions: ConfigLoadOptions

  #### Returns ModuleApplication<M, O, Env>

  Overrides Application.constructor

  - Defined in module-application.ts:20

##
Properties

### app

app: null | NgModuleRef$1<M> = null

Inherited from Application.app

- Defined in application.ts:39

### config

config: null | ConfigService<Record<string, any>> = null

Inherited from Application.config

- Defined in application.ts:41

### `Optional` `Readonly` configLoadOptions

configLoadOptions?: ConfigLoadOptions

Inherited from Application.configLoadOptions

- Defined in application.ts:48

### `Readonly` environment

environment: Env

Inherited from Application.environment

- Defined in application.ts:46

### logger

logger: null | Console = null

Inherited from Application.logger

- Defined in application.ts:40

### `Readonly` options

options: O = ...

Inherited from Application.options

- Defined in application.ts:47

##
Methods

### after

- after(fnc: ApplicationAfterFunction<O, NgModuleRef$1<M>, Env>): void

  #### Parameters

  - fnc: ApplicationAfterFunction<O, NgModuleRef$1<M>, Env>

  #### Returns void

  Inherited from Application.after

  - Defined in application.ts:90

### before

- before(fnc: ApplicationBeforeFunction<O, NgModuleRef$1<M>, Env>): void

  #### Parameters

  - fnc: ApplicationBeforeFunction<O, NgModuleRef$1<M>, Env>

  #### Returns void

  Inherited from Application.before

  - Defined in application.ts:86

### bootstrap

- bootstrap(): Promise<void>

  #### Returns Promise<void>

  Inherited from Application.bootstrap

  - Defined in application.ts:51

### `Protected` create

- create(): Promise<NgModuleRef$1<M>>

  #### Returns Promise<NgModuleRef$1<M>>

  Overrides Application.create

  - Defined in module-application.ts:29

### `Protected` handleAfter

- handleAfter(
  app: NgModuleRef$1,
  logger: Console,
  config: ConfigService,
  options: O,
  environment: Env,
  ): Promise<void>

  #### Parameters

  - app: NgModuleRef$1
  - logger: Console
  - config: ConfigService
  - options: O
  - environment: Env

  #### Returns Promise<void>

  Inherited from Application.handleAfter

  - Defined in application.ts:100

### `Protected` handleBefore

- handleBefore(config: ConfigService, options: O, environment: Env): Promise<void>

  #### Parameters

  - config: ConfigService
  - options: O
  - environment: Env

  #### Returns Promise<void>

  Inherited from Application.handleBefore

  - Defined in application.ts:94

### `Protected` loadConfig

- loadConfig(environment: Env): Promise<void>

  #### Parameters

  - environment: Env

  #### Returns Promise<void>

  Inherited from Application.loadConfig

  - Defined in application.ts:106

### `Protected` prepareConfig

- prepareConfig(config: O): void

  #### Parameters

  - config: O

  #### Returns void

  Overrides Application.prepareConfig

  - Defined in module-application.ts:34

### `Protected` prepareEnvironment

- prepareEnvironment(environment: Env): Promise<void>

  #### Parameters

  - environment: Env

  #### Returns Promise<void>

  Inherited from Application.prepareEnvironment

  - Defined in application.ts:110